package fr.bhprod.sga.map.editor.swing;

import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;
import javax.swing.JPanel;

import com.jme.system.DisplaySystem;
import com.jmex.awt.JMECanvas;
import com.jmex.awt.JMECanvasImplementor;

import fr.bhprod.sga.map.editor.gl.MapCanvasImpl;

/**
 * 
 * @author jbeaufils
 * @version 1.0
 */

public class MapFrame extends JFrame implements ComponentListener, WindowListener {

	private static final long serialVersionUID = -6611658323035609573L;

	public static final int SCREEN_WIDTH = 150;

	public static final int SCREEN_HEIGHT = 200;

	JPanel contentPane;

	JPanel mainPanel = new JPanel();

	Canvas comp = null;

	JMECanvasImplementor impl;

	MapMenu menu = null;

	public MapFrame() {
        setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

		addWindowListener(this);
		addComponentListener(this);

		menu = new MapMenu(this);
		
		init();
		pack();

		new Thread() {
			{
				setDaemon(true);
			}

			public void run() {
				while (true) {
					comp.repaint();
					yield();
				}
			}
		}.start();

		comp.addKeyListener((MapCanvasImpl)impl);
		comp.addMouseListener((MapCanvasImpl)impl);
		comp.addMouseMotionListener((MapCanvasImpl)impl);
		comp.requestFocus();
		
		menu.setMapCanvas((MapCanvasImpl)impl);
	}

	private void init() {
		contentPane = (JPanel) this.getContentPane();

		setTitle("SGA Map Editor");

		comp = DisplaySystem.getDisplaySystem().createCanvas(SCREEN_WIDTH,
				SCREEN_HEIGHT);

		impl = new MapCanvasImpl(SCREEN_WIDTH, SCREEN_HEIGHT, menu);
		((JMECanvas) comp).setImplementor(impl);

		comp.setBounds(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
		
		contentPane.add(comp, BorderLayout.CENTER);
	}

	public void windowClosing(WindowEvent event) {
		MapMenuAction.quit(this);
	}

	public void componentResized(ComponentEvent event) {
		impl.resizeCanvas(getWidth(), getHeight());
	}

	
	
	public void windowOpened(WindowEvent event) {
	}

	public void windowClosed(WindowEvent event) {
	}

	public void windowIconified(WindowEvent event) {
	}

	public void windowDeiconified(WindowEvent event) {
	}

	public void windowActivated(WindowEvent event) {
	}

	public void windowDeactivated(WindowEvent event) {
	}
	
	public void componentMoved(ComponentEvent event) {
	}

	public void componentShown(ComponentEvent event) {
	}

	public void componentHidden(ComponentEvent event) {
	}

}
